#include <iostream>
#include <iomanip>
#include <fstream>
#include <string.h>
#include <stdlib.h>

#define MAX 11
using namespace std;

int lineno = 0;

inline int get_oplus(const int op_plus[MAX][MAX], int elem_a, int elem_b) {
	return op_plus[elem_a][elem_b];	
}

inline bool is_defined(const int op_plus[MAX][MAX], int elem_a, int elem_b) {
	return (get_oplus(op_plus, elem_a, elem_b) != -1);
}


bool condition(int n, int op_plus[MAX][MAX]) {
	for (int i = 0; i < n; i++)
	for (int j = 0; j < n; j++)
		if (is_defined(op_plus, i, j)) {
			bool found_c = false;
			int result = get_oplus(op_plus, i, j);

			for (int k = 0; k < n; k++)
				if (get_oplus(op_plus, k, i) == result) {
					found_c = true;
					break;
				}
			if (!found_c)
				return false;

			bool found_d = false;


			for (int k = 0; k < n; k++)
				if (get_oplus(op_plus, j, k) == result) {
					found_d = true;
					break;
				}
			if (!found_d)
				return false;
		}
	return true;
}

bool parse_prepea(int num, ifstream &fin, int oplus[MAX][MAX], int ortholeft[MAX], int orthoright[MAX]) {

	char buffer[2048];
	int currenti = 0;

	fin.getline(buffer, 2048);
	lineno++;

	// skip empty lines and lines beginning with Order
	while (fin.good()) {
		// end of line
		if (!fin.good())
			return false;
		else {
			if (!strncmp(buffer, "Order", 5) || buffer[0]=='\0') {
				fin.getline(buffer, 2048);
				lineno++;

				if (!fin.good()) 
					return false;
			}
			else
				break;

		}
	}

	if (!fin.good())
		return false;

	while (fin.good() && currenti < num) {
		char *pom = buffer;

#if 0
		if (!strncmp(pom,"Order", 5) || !*pom) {
			// skip line
			fin.getline(buffer, 2048);
			lineno++;
			continue;
		}
#endif
		for (int i = 0; i < num; i++) {
			// skip white spaces
			while (*pom == ' ' || *pom == '\t')
				pom++;
			
			int value = 0;
			char *pom_test = pom;
			
			if (*pom == '.') {
				oplus[currenti][i] = -1;
				pom++;
			}		
			else {
				while (*pom >= '0' && *pom <= '9') {
					value = 10*value + (*pom-'0');
					pom++;
				}
				if (pom_test == pom) {
					// no number was read
					cerr << " Error on the line " << lineno << " at position " << (int)(pom-buffer)+1 << "."<< endl << "Expecting number." << endl;
					cerr << buffer << endl;
					fin.close();
					return false;
				}
				else {
					oplus[currenti][i] = value;
				}
			}

			
		}
		fin.getline(buffer, 2048);
		lineno++;
		currenti++;
	}

	

		//next line Left orthosupplement
		char *pom = buffer;

		if (!strncmp(pom, "Left", 4)) {
			fin.getline(buffer, 2048);
			lineno++;
		}
		else {
			cerr << "Error: Expecting Left." << endl;
			fin.close();
			return false;
		}

		if (!fin.good()) {
			cerr << "Error: Expecting Left." << endl;
			fin.close();
			return false;
		}
		
		pom = buffer;

		for (int i = 0; i < num; i++) {
			// skip white spaces
			while (*pom == ' ' || *pom == '\t')
				pom++;
			
			int value = 0;
			char *pom_test = pom;
			while (*pom >= '0' && *pom <= '9') {
				value = 10*value + (*pom-'0');
				pom++;
			}
			if (pom_test == pom) {
				// no number was read
				cerr << " Error on the line " << lineno << " at position " << (int)(pom-buffer)+1 << "."<< endl << "Expecting number." << endl;
				fin.close();
				return false;
			}
			else {
				ortholeft[i] = value;
			}
		}
		fin.getline(buffer, 2048);
		lineno++;
		if (!fin.good()) {
			cerr << "Error: expecting Right." << endl;
			fin.close();
			return false;
		}

		if (!strncmp(buffer, "Right", 5)) {
			fin.getline(buffer, 2048);
			lineno++;
		}
		else {
			cerr << "Error: expecting Right." << endl;
			fin.close();
			return false;
		}
		if (!fin.good()) {
			cerr << "Error: expecting Right." << endl;
			fin.close();
			return false;
		}
		
		pom = buffer;

		for (int i = 0; i < num; i++) {
			// skip white spaces
			while (*pom == ' ' || *pom == '\t')
				pom++;
			
			int value = 0;
			char *pom_test = pom;
			while (*pom >= '0' && *pom <= '9') {
				value = 10*value + (*pom-'0');
				pom++;
			}
			if (pom_test == pom) {
				// no number was read
				cerr << " Error on the line " << lineno << " at position " << (int)(pom-buffer)+1 << "."<< endl << "Expecting number." << endl;
				fin.close();
				return false;
			}
			else {
				orthoright[i] = value;
			}
		}
	return true;
}


int main(int argc, char** argv) {
	ifstream fin;
	int oplus[MAX][MAX];
	int ortholeft[MAX];
	int orthoright[MAX];

	if (argc < 3) {
	}
	else {
		int num = atoi(argv[1]);

		fin.open(argv[2], ifstream::in);
		if (fin.good()) {
			while (parse_prepea(num, fin, oplus, ortholeft, orthoright)) {

				for (int i = 0 ; i < num ; i++) {
					for (int j = 0 ; j < num ; j++) cout << setw(3) << oplus[i][j] ; 
					cout << endl;
				}

				cout << " Left:";
				for (int i = 0 ; i < num ; i++) 
					cout << setw(3) << ortholeft[i] << " ";
				cout << endl;

				cout << "Right:";
				for (int i = 0 ; i < num ; i++) 
					cout << setw(3) << orthoright[i] << " ";
				cout << endl;

				if (condition(num, oplus)) {
					cout << "::PrePEA::" << endl;
				}
				cout << endl;


			}


			fin.close();

		}
		else {
			cerr << "Error: Cannot open '" << argv[2] << "' file." << endl;
			return 1;
		}
	}
	return 0;
}
