#include <iostream>
#include <iomanip>
#include "consts.h"

using namespace std;

#include "orders8.h"

void init_dot(int n, int dot[MAX][MAX]) {
	for (int i = 0; i < n - 1; i++)
	for (int j = 0; j < n - 1; j++)
		dot[i][j] = -1;

	for (int i = 0; i < n; i++)
		dot[i][n-1] = dot[n-1][i] = i;
}

void init_impl(int n, int impl[MAX][MAX]) {
	for (int i = 0; i < n ; i++)
	for (int j = 0; j < n ; j++)
		impl[i][j] = -1;

	for (int i = 0; i < n; i++) {
		impl[n-1][i] = i;
		impl[i][i] = n - 1;
	}

}

bool test_revorder(int n, int ordersmall[MAX][MAX], int impl[MAX][MAX]) {
		for (int i = 1; i < n - 1; i++)
		for (int j = 1; j < n - 1; j++)
			if (ordersmall[i - 1][j - 1] && !ordersmall[impl[j][0] - 1][impl[i][0] - 1])
				return false;

		return true;
}	


bool test_impl0cond(int n, int impl[MAX][MAX]) {
	for (int i = 0; i < n; i++)
	for (int j = 0; j < n; j++)
		if (impl[i][j] != -1) {
			if (impl[impl[j][0]][impl[i][0]] != impl[i][j])
				return false;
		}
	return true;
}

inline bool isless(int n, int ordersmall[MAX][MAX], int x, int y) {
	if (x == 0 || y == n - 1)
		return true;
	if (x > 0 && x < n - 1 && y > 0 && y < n - 1)
		return ordersmall[x - 1][y - 1];
	return false;
}
bool test_0implmono(int n, int ordersmall[MAX][MAX], int impl[MAX][MAX]) {
	for (int i = 0; i < n; i++)
		for (int j = 1; j < n; j++)
			if (impl[i][j] != -1 && !isless(n, ordersmall, impl[i][0], impl[i][j])) {
				cout << "(" << i << ", " << j << ")" << endl;
				return true;
			}
	return false;

}

bool test_residual(int n, int dot[MAX][MAX], int impl[MAX][MAX]) {
	for (int i = 0; i < n; i++)
	for (int j = 0; j < n; j++)
	for (int k = 0; k < n; k++)
		if (dot[i][j]!= -1 && impl[j][k]!=-1) {
			if ((dot[i][j] == k && i != impl[j][k]) ||
			    (i == impl[j][k] && k != dot[i][j]))
				return false;

			    	
		}
	
	return true;
}

void gen_dot(int x, int y, int n, int ordersmall[MAX][MAX], int dot[MAX][MAX], int impl[MAX][MAX]) {
	if (x == n - 1) {
		if (test_residual(n, dot, impl) && test_0implmono(n, ordersmall, impl)) {
			cout << "Dot: " << endl;
			for (int i = 0; i < n; i++) {
				for (int j = 0; j < n; j++)
					cout << setw(3) << dot[i][j];

				cout << endl;
			}
			cout << "Impl: " << endl;
			for (int i = 0; i < n; i++) {
				for (int j = 0; j < n; j++)
					cout << setw(3) << impl[i][j];

				cout << endl;
			}
			cout << endl;

		}
		
	}
	else {
		// x.y is defined
		if (ordersmall[impl[x][0] - 1][y - 1]) {
			for (int i = 0; i <= min(x,y); i++) {
				if ((i == 0 || (ordersmall[i - 1][x - 1] && ordersmall[i - 1][y - 1]))) {
				dot[x][y] =  i;
				dot[y][x] =  i;
				if (y < n - 2)
					gen_dot(x, y + 1, n, ordersmall, dot, impl);
				else
					gen_dot(x + 1, x + 1, n, ordersmall, dot, impl);
				dot[x][y] = -1;
				dot[y][x] = -1;


						}
			}
		}
		else {
				if (y < n - 2)
					gen_dot(x, y + 1, n, ordersmall, dot, impl);
				else
					gen_dot(x + 1, x + 1, n, ordersmall, dot, impl);
		}
	}
}

void gen_rest_impl(int x, int y, int n, int ordersmall[MAX][MAX], int dot[MAX][MAX], int impl[MAX][MAX]) {
	if (x == n - 1) {
		if (test_impl0cond(n, impl)) {

#if 0
			cout << "Implication candidate:" << endl;
			for (int i = 0; i < n; i++) {
				for (int j = 0; j < n; j++) 
					cout << setw(3) << impl[i][j];
				cout << endl;
			}
			cout << endl;
#endif
			gen_dot(1,1,n, ordersmall, dot, impl);
		}
	}
	else {
		if (x !=y && ordersmall[y - 1][x - 1]) {
			for (int i = 0; i < n; i++) {
				impl[x][y] = i;
				if (y < n - 2)
					gen_rest_impl(x, y + 1, n, ordersmall, dot, impl);
				else
					gen_rest_impl(x+1, 1,  n, ordersmall, dot, impl);
				impl[x][y] = -1;

			}
		}
		else {
				if (y < n - 2)
					gen_rest_impl(x, y + 1, n, ordersmall, dot, impl);
				else
					gen_rest_impl(x+1, 1,  n, ordersmall, dot, impl);
		}
				
		
	}
}


void gen_impl0(int level, int n, int ordersmall[MAX][MAX], int dot[MAX][MAX], int impl[MAX][MAX]) {
	if (level == n - 1) {
		if (test_revorder(n, ordersmall, impl)) {
			gen_rest_impl(1,1,n, ordersmall,dot,impl);
		}
				
	}
	else {
		for (int i = 0; i < n; i++) {
			impl[level][0] = i;
			gen_impl0(level + 1, n, ordersmall, dot, impl);
			impl[level][0] = -1;
		}

	}
}




int main() {
	
	int n = 8;

	int dot[MAX][MAX], impl[MAX][MAX];

	init_dot(n, dot);
	init_impl(n, impl);

	for (int i = 0; i < order8count; i++) {
		cout << "Order " << i + 1 << endl;
		for (int j = 0; j < n-2; j++) {
			for (int k = 0; k < n-2; k++)
				cout << setw(2) << orders8small[i][j][k];
			cout << endl;
		}
		cout << endl;


		gen_impl0(1, n, orders8small[i], dot, impl);
	}


	return 0;
}
