#include "wprepea.h"

wprepea::wprepea() {
	n = 0;
}

wprepea::wprepea(signed char n, signed char oplus[MAX][MAX], signed char left_ortho[MAX], signed char right_ortho[MAX]) {
		this->n = n;
		for (int i = 0; i < n; i++)
		for (int j = 0; j < n; j++)
			this->oplus[i][j] = oplus[i][j];

		for (int i = 0; i < n; i++) {
			this->left_ortho[i] = left_ortho[i];
			this->right_ortho[i] = right_ortho[i];
		}
}

wprepea::wprepea(const struct wprepea &wp) {
		this->n = wp.n;
		for (int i = 0; i < wp.n; i++)
		for (int j = 0; j < wp.n; j++)
			this->oplus[i][j] = wp.oplus[i][j];

		for (int i = 0; i < wp.n; i++) {
			this->left_ortho[i] = wp.left_ortho[i];
			this->right_ortho[i] = wp.right_ortho[i];
		}
}

bool operator==(const struct wprepea &wp1, const struct wprepea &wp2) {
#ifdef DEBUG
		cout << "HERE..." << endl;
#endif
		if (wp1.n != wp2.n) {
#ifdef DEBUG

			cout << "Failed size compare: " << wp1.n << " vs. " << wp2.n << endl;
#endif
			return false;
		}
		for (int i = 1; i < wp1.n-1; i++)
		for (int j = 1; j < wp1.n-1; j++)
			if (wp1.oplus[i][j] != wp2.oplus[i][j]) {
#ifdef DEBUG
				cout << "Failed oplus compare: (" << i << ", " << j << ")" << endl;
#endif
				return false;
			}
		
		for (int i = 1; i < wp1.n - 1; i++)
			if (wp1.left_ortho[i] != wp2.left_ortho[i]) {
#ifdef DEBUG
				cout << "Failed left_ortho compare: " << i << " " << wp1.left_ortho[i] << " vs. " << wp2.left_ortho[i] << endl;
#endif
				return false;
			}

		for (int i = 1; i < wp1.n - 1; i++)
			if (wp1.right_ortho[i] != wp2.right_ortho[i]) {
#ifdef DEBUG

				cout << "Failed right_ortho compare: " << i << " " << wp1.right_ortho[i] << " vs. " << wp2.right_ortho[i] << endl;
#endif
				return false;
			}

#ifdef DEBUG
		cout << "Not failed - are the same" << endl;
#endif
		return true;
	}



bool operator<(const struct wprepea &wp1, const struct wprepea &wp2) {

		#ifdef DEBUG
		cout << "H<RE" << endl;

		print_op(wp1.n, wp1.oplus);
		cout << "---" << endl;
		print_op(wp2.n, wp2.oplus);
		cout << "---" << endl;
		#endif

		for (int i = 1; i < wp1.n-1; i++)
		for (int j = 1; j < wp1.n-1; j++)
			if (wp1.oplus[i][j] != wp2.oplus[i][j]) {
				if (wp1.oplus[i][j] < wp2.oplus[i][j])
					return true;
				else
					return false;
			}

		for (int i = 1; i < wp1.n - 1; i++)
			if (wp1.left_ortho[i] != wp2.left_ortho[i]) {
				if (wp1.left_ortho[i] < wp2.left_ortho[i])
					return true;
				else
					return false;
			}

		for (int i = 1; i < wp1.n - 1; i++)
			if (wp1.right_ortho[i] != wp2.right_ortho[i]) {
				if (wp1.right_ortho[i] < wp2.right_ortho[i])
					return true;
				else
					return false;
			}

		return false;
	}
