#pragma once

#include "consts.h"
#include "wprepea.h"

#include <set>
#include <map>
#include <iostream>

using namespace std;

struct permutation {
	int length;
	int perm[MAX];

	permutation();
	permutation(int length, int perm[MAX]);
	permutation(const struct permutation &perm);
};



struct todoElem {
	signed char x, y;
	
	todoElem(int _x, int _y):x(_x), y(_y) {}
	friend bool operator<(const struct todoElem &te1, const struct todoElem &te2);
};

bool init_set_todo(signed char n, set<todoElem> &set_todo, int ordersmall[MAX][MAX], signed char left_ortho[MAX], signed char right_ortho[MAX]); 

void set_initial_plus(signed char n, signed char op_plus[MAX][MAX]); 

bool is_admissible(signed char n, int ordersmall[MAX][MAX], signed char perm[MAX]); 
void compute_inverse_perm(signed char n, signed char perm[MAX], signed char perm_inv[MAX]); 

void isoimage(const struct wprepea wp1, int isomorphism[MAX], struct wprepea &wp2); 

void update_ISOS_recursive(int level, int ordersmall[MAX][MAX], const struct wprepea wp, int perm[MAX], set<struct wprepea> &setWPES, set<struct wprepea> &setISOS);
void update_ISOS(int ordersmall[MAX][MAX], const struct wprepea wp, set<struct wprepea> &setWPES, set<struct wprepea> &setISOS);

void update_ISOS_with_map(int ordersmall[MAX][MAX], const struct wprepea wp, set<struct wprepea> &setWPES, set<struct wprepea> &setISOS, map<wprepea, pair<wprepea, permutation> > &isomap); 

void update_ISOS_with_map_recursive(int level, int ordersmall[MAX][MAX], const struct wprepea wp, int perm[MAX], set<struct wprepea> &setWPES, set<struct wprepea> &setISOS, map<wprepea, pair<wprepea, permutation> > &isomap); 



inline int get_oplus(const signed char op_plus[MAX][MAX], int elem_a, int elem_b) {
	return op_plus[elem_a][elem_b];	
}

inline void set_oplus(signed char op_plus[MAX][MAX], int elem_a, int elem_b, signed char value) {
	op_plus[elem_a][elem_b] = value;
}

inline bool is_defined(const signed char op_plus[MAX][MAX], int elem_a, int elem_b) {
	return (get_oplus(op_plus, elem_a, elem_b) != -1);
}

void init_dependency_map(const set<todoElem> set_todo, int ordersmall[MAX][MAX], map<todoElem, set<todoElem> > &dependencyMap); 
void reduce_dependency_map(map<todoElem, set<todoElem> > &dependencyMap); 
void display_dependency_map(ostream &os, const map<todoElem, set<todoElem> > &dependencyMap); 
void print_op(ostream &os, signed char n, const signed char op[MAX][MAX]); 

struct setpermElem {
	signed char n;
	signed char perm[MAX];

	setpermElem(signed char _n, signed char _perm[MAX]) {
		n = _n;	
		for (int i = 0; i < n; i++)
			perm[i] = _perm[i];
	}

	friend bool operator<(const struct setpermElem &spe1, const struct setpermElem &spe2);
};

void init_ones(signed char n, signed char oplus[MAX][MAX], signed char perm_left[MAX], signed char perm_right[MAX]); 

bool test_associativity(signed char n, signed char op_plus[MAX][MAX]); 
bool condition(signed char n, signed char op_plus[MAX][MAX]); 
bool is_weak_pre_pea(signed char n, signed char oplus[MAX][MAX], signed char compl_right[MAX], signed char compl_left[MAX]); 

bool preserve_order(int n, int ordersmall[MAX][MAX], signed char perm[MAX]); 
void update_set_perm(int level, int ordersmall[MAX][MAX], set<setpermElem> &setPERM, int n, signed char perm[MAX], signed char perm_iso[MAX], const bool is_plan = false); 

bool test_order_ortho(signed char n, int ordersmall[MAX][MAX], signed char left_ortho[MAX], signed char right_ortho[MAX]); 

bool isFromUpperBound(const map<todoElem, set<todoElem> > &dependencyMap, const todoElem &elem, int &idx, int n, signed char oplus[MAX][MAX], int ordersmall[MAX][MAX]); 

bool testAssocCheckMap(map< pair<signed char, signed char>, set<signed char> > &assocCheckMap, const todoElem &elem, int &idx, int n, signed char oplus[MAX][MAX], signed char perm_left[MAX], signed char perm_right[MAX], int ordersmall[MAX][MAX]); 
bool are_left_right_orders_equal(signed char n, signed char op_plus[MAX][MAX], signed char left_ortho[MAX], signed char right_ortho[MAX]);

